package consommation;

public class ConsommationFonctionVitesseFonctionMoyennes implements ConsommationFonctionVitesseInterface {

    private Consommation consoSurRoute;
    private Consommation consoUrbaine;
    private Consommation consoMixte;
    
    public ConsommationFonctionVitesseFonctionMoyennes(Consommation consoSurRoute,Consommation consoUrbaine, Consommation consoMixte ) {
       this.consoSurRoute = consoSurRoute;
       this.consoUrbaine = consoUrbaine;
       this.consoMixte = consoMixte;
    }
    private double getCoeff(Vitesse v) {
        double coeff =  Math.pow( 10, -4); 
        //Au dessus de 100 km/h on prend en compte la consommation sur route que l'on multiplie par 10^-4,
        if (v.getValeur()>100){
            return coeff*consoSurRoute.getValeur();}
        if (v.getValeur()>50)
            return coeff*consoMixte.getValeur();
        return coeff*consoUrbaine.getValeur();
    }
    //@todo travailler avec les units
    //@todo optimiser pour eviter la vitesse
    public Consommation consommationSiVitesse(Vitesse aV) {
        double vitesse = aV.getValeur();
        double v = 2*(100/vitesse) + getCoeff(aV)*vitesse*vitesse;
        return new Consommation(v, Unite.LITRES_PAR_100KM);
    }
    @Override
    public String toString() {
        return "Consommations [consoSurRoute="
                + consoSurRoute + ", consoUrbaine=" + consoUrbaine
                + ", consoMixte=" + consoMixte + "]";
    }
}
