package consommation;

public class DonneesDeConsommation implements DonneesDeConsommationInterface {
    private ConsommationMoyenneInterface cm;
    private ConsommationFonctionVitesseInterface cv;
    
    public DonneesDeConsommation(ConsommationMoyenneInterface cm,
            ConsommationFonctionVitesseAvecCoefficient cv) {
        super();
        this.cm = cm;
        this.cv = cv;
    }

    public DonneesDeConsommation() {
        this(null,null);
    }

    @Override
    public Consommation consommationSiVitesse(Vitesse aV) {
        if (cv==null)
            return null;
        return cv.consommationSiVitesse(aV);
    }

    @Override
    public Consommation consommation(TypeRoute aSorte) {
        if (cm==null)
            return null;
        return cm.consommation(aSorte);
    }


    @Override
    public void setConsommationMoyenne(ConsommationMoyenneInterface cm) {
       this.cm = cm;
        
    }

    @Override
    public void setConsommationFonctionVitesse(
            ConsommationFonctionVitesseInterface cv) {
        this.cv = cv;
    }

    @Override
    public String toString() {
        return " ["+ cm + ", cv=" + cv + "]";
    }
    
    
}
