package consommation;

import java.io.IOException;
import java.util.HashMap;

import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.SerializationFeature;

public class ServiceExterne {
    private HashMap<String, ConsommationMoyenneInterface> listeConsommations = new HashMap<String, ConsommationMoyenneInterface>();
    private static final ConsommationMoyenneInterface defaultConso = new ConsommationMoyenne(
                               new Consommation(4,Unite.LITRES_PAR_100KM), 
                               new Consommation(8,Unite.LITRES_PAR_100KM), 
                               new Consommation(6,Unite.LITRES_PAR_100KM));
    
	public ServiceExterne() {
	    Consommation consoUrbain = new Consommation(26.91,Unite.LITRES_PAR_100KM);
	    Consommation consoRoute = new Consommation(13.30,Unite.LITRES_PAR_100KM);
	    Consommation consoMixte = new Consommation(18.30,Unite.LITRES_PAR_100KM);
	    ConsommationMoyenne cm = new ConsommationMoyenne(consoRoute,consoUrbain,consoMixte);
	    listeConsommations.put("ferrariF430", cm);
        
    }


    public String consommationJSON(String modele) throws JsonParseException, JsonMappingException, JsonProcessingException, IOException {
        ConsommationMoyenneInterface cm ;
        if (listeConsommations.containsKey(modele)) 
            cm = listeConsommations.get(modele);
       else
           cm = defaultConso;
                
      ObjectMapper objectMapper = new ObjectMapper();
      objectMapper.configure(SerializationFeature.FAIL_ON_EMPTY_BEANS, false);  
      Object json = objectMapper.readValue(
                objectMapper.writeValueAsString(cm), Object.class);
      String jsonString = objectMapper.writerWithDefaultPrettyPrinter()
                .writeValueAsString(json);
      return jsonString;
         
	}
}